
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef IVMOB_SCAN_H
#define IVMOB_SCAN_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/genBasicTclservClientDecode.h"

#include "server/tclservClient/genPosTclservClientDecode.h"

#include "server/tclservClient/pomTclservClientDecode.h"


/* Structures du module */
#include "server/ivmobPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
int scan_buf_struct_IVMOB_STATUS_POSTER_STR (char** buf, struct IVMOB_STATUS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_REF_POSTER_STR (char** buf, struct IVMOB_REF_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_ODO_POSTER_STR (char** buf, struct IVMOB_ODO_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_MEPOS_POSTER_STR (char** buf, struct IVMOB_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_STR (char** buf, struct IVMOB_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_MAX_ACCEL (char** buf, struct IVMOB_MAX_ACCEL *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_GYRO_ASSERV (char** buf, struct IVMOB_GYRO_ASSERV *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_GYRO (char** buf, struct IVMOB_GYRO *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_GYRO_PARAMS (char** buf, struct IVMOB_GYRO_PARAMS *x, int nDim, int *dims );
int scan_buf_enum_IVMOB_GYRO_MODE (char** buf, enum IVMOB_GYRO_MODE *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_ODOMETRY_METHOD (char** buf, struct IVMOB_ODOMETRY_METHOD *x, int nDim, int *dims );
int scan_buf_enum_IVMOB_ODOMETRY_MODE (char** buf, enum IVMOB_ODOMETRY_MODE *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_CART_3DCONFIG (char** buf, struct IVMOB_CART_3DCONFIG *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_CART_3DSTATE (char** buf, struct IVMOB_CART_3DSTATE *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_TRACK_PARAMS (char** buf, struct IVMOB_TRACK_PARAMS *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_VAR_PARAMS (char** buf, struct IVMOB_VAR_PARAMS *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_DYNAMIC_STR (char** buf, struct IVMOB_DYNAMIC_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_KINEMATICS_STR (char** buf, struct IVMOB_KINEMATICS_STR *x, int nDim, int *dims );
int scan_buf_struct_IVMOB_STATUS_STR (char** buf, struct IVMOB_STATUS_STR *x, int nDim, int *dims );
int scan_buf_enum_IVMOB_MODE (char** buf, enum IVMOB_MODE *x, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

int scan_buf_IVMOB_MODE (char** buf, IVMOB_MODE *x, int nDim, int *dims );
int scan_buf_IVMOB_STATUS_STR (char** buf, IVMOB_STATUS_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_KINEMATICS_STR (char** buf, IVMOB_KINEMATICS_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_DYNAMIC_STR (char** buf, IVMOB_DYNAMIC_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_VAR_PARAMS (char** buf, IVMOB_VAR_PARAMS *x, int nDim, int *dims );
int scan_buf_IVMOB_TRACK_PARAMS (char** buf, IVMOB_TRACK_PARAMS *x, int nDim, int *dims );
int scan_buf_IVMOB_CART_3DSTATE (char** buf, IVMOB_CART_3DSTATE *x, int nDim, int *dims );
int scan_buf_IVMOB_CART_3DCONFIG (char** buf, IVMOB_CART_3DCONFIG *x, int nDim, int *dims );
int scan_buf_IVMOB_ODOMETRY_MODE (char** buf, IVMOB_ODOMETRY_MODE *x, int nDim, int *dims );
int scan_buf_IVMOB_ODOMETRY_METHOD (char** buf, IVMOB_ODOMETRY_METHOD *x, int nDim, int *dims );
int scan_buf_IVMOB_GYRO_MODE (char** buf, IVMOB_GYRO_MODE *x, int nDim, int *dims );
int scan_buf_IVMOB_GYRO_PARAMS (char** buf, IVMOB_GYRO_PARAMS *x, int nDim, int *dims );
int scan_buf_IVMOB_GYRO (char** buf, IVMOB_GYRO *x, int nDim, int *dims );
int scan_buf_IVMOB_GYRO_ASSERV (char** buf, IVMOB_GYRO_ASSERV *x, int nDim, int *dims );
int scan_buf_IVMOB_MAX_ACCEL (char** buf, IVMOB_MAX_ACCEL *x, int nDim, int *dims );
int scan_buf_IVMOB_STR (char** buf, IVMOB_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_MEPOS_POSTER_STR (char** buf, IVMOB_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_ODO_POSTER_STR (char** buf, IVMOB_ODO_POSTER_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_REF_POSTER_STR (char** buf, IVMOB_REF_POSTER_STR *x, int nDim, int *dims );
int scan_buf_IVMOB_STATUS_POSTER_STR (char** buf, IVMOB_STATUS_POSTER_STR *x, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* IVMOB_SCAN_H */

