
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] ivmobInstall] >= 0 } {
    interp expose {} ivmobInstall
}

proc ::ivmobInstall { name } {
    foreach rqst { "Init" "Activate" "SetCmdParam" "SetKinematicsParam" "GetKinematicsParam" "GetDynamicsParam" "SetDynamicsParam" "SetVarParam" "Stop" "Track" "SetPom" "SetPos" "Gyro" "GetGyro" "SetOdometryMethod" "Log" "StopLog" "LogInternalData" "StopInternalDataLog" "Goto" "MEPosmePosPosterRead" "OdoRobotPosterRead" "OdoVarPosterRead" "OdoRobot3dPosterRead" "RefrefPosterRead" "StatusstatusPosterRead" "StatusgyroPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} ivmob$rqst $name
    }
}

interp hide {} ivmobInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobInit] >= 0 } {
    interp expose {} ivmobInit
}
if { [lsearch [interp hidden] ivmobInitFormatOutput] >= 0 } {
    interp expose {} ivmobInitFormatOutput
}

proc ::ivmobInit { name args } {
    set format {}
    lappend format [list string "device.name" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Connect to USB bus" \
	"GEN_STRING32\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::ivmobInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobInit
interp hide {} ivmobInitFormatOutput





# Activate ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobActivate] >= 0 } {
    interp expose {} ivmobActivate
}
if { [lsearch [interp hidden] ivmobActivateFormatOutput] >= 0 } {
    interp expose {} ivmobActivateFormatOutput
}

proc ::ivmobActivate { name args } {
    set format {}
    lappend format [list int "active" 0 ]

    return [ ::cs::rqstSend "${name}" "Activate" \
	"Switch active mode" \
	"int active\n" \
	1 \
	$format \
	$args ]
}


proc ::ivmobActivateFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobActivate
interp hide {} ivmobActivateFormatOutput





# SetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetCmdParam] >= 0 } {
    interp expose {} ivmobSetCmdParam
}
if { [lsearch [interp hidden] ivmobSetCmdParamFormatOutput] >= 0 } {
    interp expose {} ivmobSetCmdParamFormatOutput
}

proc ::ivmobSetCmdParam { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]
    lappend format [list double "cmd.longitMaxGap" 0.0 ]
    lappend format [list double "cmd.transvMaxGap" 0.0 ]
    lappend format [list double "cmd.angMaxGap" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdParam" \
	"Set command parameters" \
	"GENPOS_CART_CMD_PARAM\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angErrorMax\n| double angMaxErrSum\n| double longitMaxGap\n| double transvMaxGap\n| double angMaxGap\n" \
	16 \
	$format \
	$args ]
}


proc ::ivmobSetCmdParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetCmdParam
interp hide {} ivmobSetCmdParamFormatOutput





# SetKinematicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetKinematicsParam] >= 0 } {
    interp expose {} ivmobSetKinematicsParam
}
if { [lsearch [interp hidden] ivmobSetKinematicsParamFormatOutput] >= 0 } {
    interp expose {} ivmobSetKinematicsParamFormatOutput
}

proc ::ivmobSetKinematicsParam { name args } {
    set format {}
    lappend format [list double "kinematics.wheelRadius" 0.0 ]
    lappend format [list double "kinematics.axisWidth" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetKinematicsParam" \
	"Set Kinematic parameters" \
	"IVMOB_KINEMATICS_STR\n| double wheelRadius\n| double axisWidth\n" \
	2 \
	$format \
	$args ]
}


proc ::ivmobSetKinematicsParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetKinematicsParam
interp hide {} ivmobSetKinematicsParamFormatOutput





# GetKinematicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobGetKinematicsParam] >= 0 } {
    interp expose {} ivmobGetKinematicsParam
}
if { [lsearch [interp hidden] ivmobGetKinematicsParamFormatOutput] >= 0 } {
    interp expose {} ivmobGetKinematicsParamFormatOutput
}

proc ::ivmobGetKinematicsParam { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetKinematicsParam" \
	"Get Kinematic parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobGetKinematicsParamFormatOutput { list } {
    set format { {} status { } { kinematics { } wheelRadius { } axisWidth } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobGetKinematicsParam
interp hide {} ivmobGetKinematicsParamFormatOutput





# GetDynamicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobGetDynamicsParam] >= 0 } {
    interp expose {} ivmobGetDynamicsParam
}
if { [lsearch [interp hidden] ivmobGetDynamicsParamFormatOutput] >= 0 } {
    interp expose {} ivmobGetDynamicsParamFormatOutput
}

proc ::ivmobGetDynamicsParam { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDynamicsParam" \
	"Get Dynamic parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobGetDynamicsParamFormatOutput { list } {
    set format { {} status { } { dynamics { } vMax { } wMax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobGetDynamicsParam
interp hide {} ivmobGetDynamicsParamFormatOutput





# SetDynamicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetDynamicsParam] >= 0 } {
    interp expose {} ivmobSetDynamicsParam
}
if { [lsearch [interp hidden] ivmobSetDynamicsParamFormatOutput] >= 0 } {
    interp expose {} ivmobSetDynamicsParamFormatOutput
}

proc ::ivmobSetDynamicsParam { name args } {
    set format {}
    lappend format [list double "dynamics.vMax" 0.0 ]
    lappend format [list double "dynamics.wMax" 0.0 ]
    lappend format [list double "dynamics.linAccelMax" 0.0 ]
    lappend format [list double "dynamics.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetDynamicsParam" \
	"Set Dynamic parameters" \
	"IVMOB_DYNAMIC_STR\n| double vMax\n| double wMax\n| double linAccelMax\n| double angAccelMax\n" \
	4 \
	$format \
	$args ]
}


proc ::ivmobSetDynamicsParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetDynamicsParam
interp hide {} ivmobSetDynamicsParamFormatOutput





# SetVarParam ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetVarParam] >= 0 } {
    interp expose {} ivmobSetVarParam
}
if { [lsearch [interp hidden] ivmobSetVarParamFormatOutput] >= 0 } {
    interp expose {} ivmobSetVarParamFormatOutput
}

proc ::ivmobSetVarParam { name args } {
    set format {}
    lappend format [list double "varParams.coeffLin" 0.0 ]
    lappend format [list double "varParams.coeffAng" 0.0 ]
    lappend format [list double "varParams.coeffLinAng" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetVarParam" \
	"Set Parameters of the uncertainty evaluation" \
	"IVMOB_VAR_PARAMS\n| double coeffLin\n| double coeffAng\n| double coeffLinAng\n" \
	3 \
	$format \
	$args ]
}


proc ::ivmobSetVarParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetVarParam
interp hide {} ivmobSetVarParamFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobStop] >= 0 } {
    interp expose {} ivmobStop
}
if { [lsearch [interp hidden] ivmobStopFormatOutput] >= 0 } {
    interp expose {} ivmobStopFormatOutput
}

proc ::ivmobStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop any on-going motion" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobStop
interp hide {} ivmobStopFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobTrack] >= 0 } {
    interp expose {} ivmobTrack
}
if { [lsearch [interp hidden] ivmobTrackFormatOutput] >= 0 } {
    interp expose {} ivmobTrackFormatOutput
}

proc ::ivmobTrack { name args } {
    set format {}
    lappend format [list string "trackParams.posterName.name" "" ]
    lappend format [list { "GENPOS_TRACK_TRAILER" "GENPOS_TRACK_SPEED" "GENPOS_TRACK_CONFIG" "GENPOS_TRACK_POS" "GENPOS_NO_TRACKING" } "trackParams.mode" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"Start tracking a reference poster" \
	"IVMOB_TRACK_PARAMS\n| GENPOS_POSTER_NAME\n| | char name\[32\]\n| GENPOS_TRACK_MODE mode\n" \
	2 \
	$format \
	$args ]
}


proc ::ivmobTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobTrack
interp hide {} ivmobTrackFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetPom] >= 0 } {
    interp expose {} ivmobSetPom
}
if { [lsearch [interp hidden] ivmobSetPomFormatOutput] >= 0 } {
    interp expose {} ivmobSetPomFormatOutput
}

proc ::ivmobSetPom { name args } {
    set format {}
    lappend format [list string "mePosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"Define the name of the global POM poster" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::ivmobSetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetPom
interp hide {} ivmobSetPomFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetPos] >= 0 } {
    interp expose {} ivmobSetPos
}
if { [lsearch [interp hidden] ivmobSetPosFormatOutput] >= 0 } {
    interp expose {} ivmobSetPosFormatOutput
}

proc ::ivmobSetPos { name args } {
    set format {}
    lappend format [list double "setPosStr.x" 0.0 ]
    lappend format [list double "setPosStr.y" 0.0 ]
    lappend format [list double "setPosStr.z" 0.0 ]
    lappend format [list double "setPosStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"IVMOB_CART_3DCONFIG\n| double x\n| double y\n| double z\n| double theta\n" \
	4 \
	$format \
	$args ]
}


proc ::ivmobSetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetPos
interp hide {} ivmobSetPosFormatOutput





# Gyro ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobGyro] >= 0 } {
    interp expose {} ivmobGyro
}
if { [lsearch [interp hidden] ivmobGyroFormatOutput] >= 0 } {
    interp expose {} ivmobGyroFormatOutput
}

proc ::ivmobGyro { name args } {
    set format {}
    lappend format [list { "IVMOB_GYRO_ON" "IVMOB_GYRO_ON_IF_MOTION" "IVMOB_GYRO_OFF" } "params.mode" "" ]
    lappend format [list string "params.port" "" ]
    lappend format [list double "params.latitude" 0.0 ]
    lappend format [list double "params.woffset" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Gyro" \
	"Gyro configuration" \
	"IVMOB_GYRO_PARAMS\n| IVMOB_GYRO_MODE mode\n| char port\[32\]\n| double latitude\n| double woffset\n" \
	4 \
	$format \
	$args ]
}


proc ::ivmobGyroFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobGyro
interp hide {} ivmobGyroFormatOutput





# GetGyro ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobGetGyro] >= 0 } {
    interp expose {} ivmobGetGyro
}
if { [lsearch [interp hidden] ivmobGetGyroFormatOutput] >= 0 } {
    interp expose {} ivmobGetGyroFormatOutput
}

proc ::ivmobGetGyro { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGyro" \
	"Returns gyro parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobGetGyroFormatOutput { list } {
    set format { {} status { } { params { } mode { } port { } latitude { } woffset } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobGetGyro
interp hide {} ivmobGetGyroFormatOutput





# SetOdometryMethod ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobSetOdometryMethod] >= 0 } {
    interp expose {} ivmobSetOdometryMethod
}
if { [lsearch [interp hidden] ivmobSetOdometryMethodFormatOutput] >= 0 } {
    interp expose {} ivmobSetOdometryMethodFormatOutput
}

proc ::ivmobSetOdometryMethod { name args } {
    set format {}
    lappend format [list { "IVMOB_ODO_3D" "IVMOB_ODO_2D" } "Odometry Method" "IVMOB_ODO_2D" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Attitude Poster Name" "imuAttitudeEstimation" ]

    return [ ::cs::rqstSend "${name}" "SetOdometryMethod" \
	"Odometry Configuration" \
	"IVMOB_ODOMETRY_METHOD\n| IVMOB_ODOMETRY_MODE mode\n| int unused\n| char attitudePosterName\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::ivmobSetOdometryMethodFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobSetOdometryMethod
interp hide {} ivmobSetOdometryMethodFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobLog] >= 0 } {
    interp expose {} ivmobLog
}
if { [lsearch [interp hidden] ivmobLogFormatOutput] >= 0 } {
    interp expose {} ivmobLogFormatOutput
}

proc ::ivmobLog { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::ivmobLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobLog
interp hide {} ivmobLogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobStopLog] >= 0 } {
    interp expose {} ivmobStopLog
}
if { [lsearch [interp hidden] ivmobStopLogFormatOutput] >= 0 } {
    interp expose {} ivmobStopLogFormatOutput
}

proc ::ivmobStopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobStopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobStopLog
interp hide {} ivmobStopLogFormatOutput





# LogInternalData ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobLogInternalData] >= 0 } {
    interp expose {} ivmobLogInternalData
}
if { [lsearch [interp hidden] ivmobLogInternalDataFormatOutput] >= 0 } {
    interp expose {} ivmobLogInternalDataFormatOutput
}

proc ::ivmobLogInternalData { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "LogInternalData" \
	"Log all the raw data provided by robot" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::ivmobLogInternalDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobLogInternalData
interp hide {} ivmobLogInternalDataFormatOutput





# StopInternalDataLog ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobStopInternalDataLog] >= 0 } {
    interp expose {} ivmobStopInternalDataLog
}
if { [lsearch [interp hidden] ivmobStopInternalDataLogFormatOutput] >= 0 } {
    interp expose {} ivmobStopInternalDataLogFormatOutput
}

proc ::ivmobStopInternalDataLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopInternalDataLog" \
	"Stop activity LogInternalLog" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::ivmobStopInternalDataLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobStopInternalDataLog
interp hide {} ivmobStopInternalDataLogFormatOutput





# Goto ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobGoto] >= 0 } {
    interp expose {} ivmobGoto
}
if { [lsearch [interp hidden] ivmobGotoFormatOutput] >= 0 } {
    interp expose {} ivmobGotoFormatOutput
}

proc ::ivmobGoto { name args } {
    set format {}
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list int "ref.tickPeriod" 0 ]
    lappend format [list { "GENPOS_POS_AND_SPEED_DATA" "GENPOS_SPEED_DATA" "GENPOS_POS_DATA" } "ref.dataType" "" ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.vt" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Goto" \
	"Set a reference data" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	14 \
	$format \
	$args ]
}


proc ::ivmobGotoFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobGoto
interp hide {} ivmobGotoFormatOutput





# MEPosmePos ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobMEPosmePosPosterRead] >= 0 } {
    interp expose {} ivmobMEPosmePosPosterRead
}
if { [lsearch [interp hidden] ivmobMEPosmePosPosterFormatOutput] >= 0 } {
    interp expose {} ivmobMEPosmePosPosterFormatOutput
}

proc ::ivmobMEPosmePosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosmePos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::ivmobMEPosmePosPosterFormatOutput { list } {
    set format { {} status { } { mePos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobMEPosmePosPosterRead
interp hide {} ivmobMEPosmePosPosterFormatOutput





# OdoRobot ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobOdoRobotPosterRead] >= 0 } {
    interp expose {} ivmobOdoRobotPosterRead
}
if { [lsearch [interp hidden] ivmobOdoRobotPosterFormatOutput] >= 0 } {
    interp expose {} ivmobOdoRobotPosterFormatOutput
}

proc ::ivmobOdoRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::ivmobOdoRobotPosterFormatOutput { list } {
    set format { {} status { } { Robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobOdoRobotPosterRead
interp hide {} ivmobOdoRobotPosterFormatOutput





# OdoVar ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobOdoVarPosterRead] >= 0 } {
    interp expose {} ivmobOdoVarPosterRead
}
if { [lsearch [interp hidden] ivmobOdoVarPosterFormatOutput] >= 0 } {
    interp expose {} ivmobOdoVarPosterFormatOutput
}

proc ::ivmobOdoVarPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoVar" \
	"GENPOS_CART_CONFIG_VAR\n| double var\[6\]\n" \
	$args ]
}


proc ::ivmobOdoVarPosterFormatOutput { list } {
    set format { {} status { } { Var { 6 } var } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobOdoVarPosterRead
interp hide {} ivmobOdoVarPosterFormatOutput





# OdoRobot3d ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobOdoRobot3dPosterRead] >= 0 } {
    interp expose {} ivmobOdoRobot3dPosterRead
}
if { [lsearch [interp hidden] ivmobOdoRobot3dPosterFormatOutput] >= 0 } {
    interp expose {} ivmobOdoRobot3dPosterFormatOutput
}

proc ::ivmobOdoRobot3dPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot3d" \
	"IVMOB_CART_3DSTATE\n| double xRef\n| double yRef\n| double zRef\n| double xRob\n| double yRob\n| double zRob\n| double theta\n| double pitch\n| double roll\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::ivmobOdoRobot3dPosterFormatOutput { list } {
    set format { {} status { } { Robot3d { } xRef { } yRef { } zRef { } xRob { } yRob { } zRob { } theta { } pitch { } roll { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobOdoRobot3dPosterRead
interp hide {} ivmobOdoRobot3dPosterFormatOutput





# Refref ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobRefrefPosterRead] >= 0 } {
    interp expose {} ivmobRefrefPosterRead
}
if { [lsearch [interp hidden] ivmobRefrefPosterFormatOutput] >= 0 } {
    interp expose {} ivmobRefrefPosterFormatOutput
}

proc ::ivmobRefrefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Refref" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::ivmobRefrefPosterFormatOutput { list } {
    set format { {} status { } { ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobRefrefPosterRead
interp hide {} ivmobRefrefPosterFormatOutput





# Statusstatus ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobStatusstatusPosterRead] >= 0 } {
    interp expose {} ivmobStatusstatusPosterRead
}
if { [lsearch [interp hidden] ivmobStatusstatusPosterFormatOutput] >= 0 } {
    interp expose {} ivmobStatusstatusPosterFormatOutput
}

proc ::ivmobStatusstatusPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statusstatus" \
	"IVMOB_STATUS_STR\n| IVMOB_MODE rs_mode\n| int operational_mode\n| double battery_level\n| double temperature\n| double v\n| double w\n| double front_left_wheel_speed\n| double front_right_wheel_speed\n| double rear_left_wheel_speed\n| double rear_right_wheel_speed\n| double front_left_current\n| double front_right_current\n| double rear_left_current\n| double rear_right_current\n| int mmi_state\n| int safety_code\n" \
	$args ]
}


proc ::ivmobStatusstatusPosterFormatOutput { list } {
    set format { {} status { } { status { } rs_mode { } operational_mode { } battery_level { } temperature { } v { } w { } front_left_wheel_speed { } front_right_wheel_speed { } rear_left_wheel_speed { } rear_right_wheel_speed { } front_left_current { } front_right_current { } rear_left_current { } rear_right_current { } mmi_state { } safety_code } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobStatusstatusPosterRead
interp hide {} ivmobStatusstatusPosterFormatOutput





# Statusgyro ----------------------------------------------------------

if { [lsearch [interp hidden] ivmobStatusgyroPosterRead] >= 0 } {
    interp expose {} ivmobStatusgyroPosterRead
}
if { [lsearch [interp hidden] ivmobStatusgyroPosterFormatOutput] >= 0 } {
    interp expose {} ivmobStatusgyroPosterFormatOutput
}

proc ::ivmobStatusgyroPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statusgyro" \
	"IVMOB_GYRO\n| IVMOB_GYRO_PARAMS\n| | IVMOB_GYRO_MODE mode\n| | char port\[32\]\n| | double latitude\n| | double woffset\n| int gyroOn\n| IVMOB_GYRO_MODE currentMode\n| double gyroToRobotOffset\n| double gyroTheta\n| double robotTheta\n| double gyroOmega\n" \
	$args ]
}


proc ::ivmobStatusgyroPosterFormatOutput { list } {
    set format { {} status { } { gyro { } { params { } mode { } port { } latitude { } woffset } { } gyroOn { } currentMode { } gyroToRobotOffset { } gyroTheta { } robotTheta { } gyroOmega } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} ivmobStatusgyroPosterRead
interp hide {} ivmobStatusgyroPosterFormatOutput


